#include <StubPreamble.h>
#include <MPIconst.h>
#include <ObjectOfJint.h>
#include <MPI_0005fComm.h>
#include <MPI_0005fDatatype.h>
#include <MPI_0005fGroup.h>
#include <MPI_0005fRequest.h>
#include <MPI_0005fErrhandler.h>
#include <MPI_0005fOp.h>
#include <mpi.h>
#include <stdlib.h>
#include <stdio.h>
#include <jci.h>

#include <unistd.h>	/* for profiling	*/

/**********************************************************************/

#define STORE_CONSTANT(MPI_CONST, typ, sig, temp_const)		\
	GET_FIELD_ID(this, MPI_CONST, sig);			\
	GET_OBJECT_FIELD(this, MPI_CONST, typ, temp_const);	\
	GET_FIELD_ID(temp_const, val, "I");			\
	SET_INT_FIELD(temp_const, val, mpi_const)

#define STORE_INT(MPI_CONST)		\
	GET_FIELD_ID(this, MPI_CONST, "I");			\
	SET_INT_FIELD(this, MPI_CONST, mpi_const)

/**********************************************************************/

ClassClass	*MPIconstClass;

/**********************************************************************/

Jint MPIconst_MPI_Init(
	JNIENV
	JOBJECT(HMPIconst) this,
	JOBJECT(HObjectOfJint) argc,
	JARRAY(HArrayOfString) argv)
{
int	argc_l;
int	i;
int	ierr;
char	**argv_l;

Jint	mpi_const;

JOBJECT(HMPI_Comm)	mpi_comm;
JOBJECT(HMPI_Op)	mpi_op;
JOBJECT(HMPI_Datatype)	mpi_datatype;
JOBJECT(HMPI_Group)	mpi_group;
JOBJECT(HMPI_Request)	mpi_request;
JOBJECT(HObjectOfJint)	objectOfJint;
JOBJECT(HMPI_Errhandler)	mpi_errhandler;

DECL_FIELD_ID(argc,val);
DECL_FIELD_ID(this,MPI_COMM_WORLD);
DECL_FIELD_ID(this,MPI_SUM);
DECL_FIELD_ID(this,MPI_MAX);
DECL_FIELD_ID(this,MPI_INT);
DECL_FIELD_ID(this,MPI_FLOAT);
DECL_FIELD_ID(this,MPI_DOUBLE);

MPIconstClass = FindClass(0, "MPIconst", 1);

/*
argc = (JOBJECT(HObjectOfJint) )execute_java_constructor(0, "Int", 0, "(I)", argc_l);
argv = (JARRAY(HArrayOfString))execute_java_constructor
				(0, "ArrayOfString", 0, "(I)", argc_l);
*/

/*
printf ("Start of MPI_init\n");
*/

GET_FIELD_ID(argc, val, "I");
GET_INT_FIELD(argc, val, (int), argc_l);
argv_l = (char **)malloc (sizeof (void *) * (argc_l + 2));
argv_l [0] = "java";	/* Java doesn't pass program name	*/
for (i = 0; i < argc_l; i++)
	argv_l [i+1] = makeCString (GET_OBJECT_ARRAY_ELEMENT(argv, i));
argv_l [i+1] = "";
argc_l++;			/* add 1 for program name	*/

/*
printf ("%d args:\n", argc_l);
for (i = 0; i < argc_l; i++)
	printf ("%s\n", argv_l [i]);
printf ("Before init - Press a key..."); getchar ();
*/

ierr = MPI_Init (&argc_l, &argv_l);

/**********************************************************************/

SET_INT_FIELD(argc, val, argc_l - 1);	/* subtract 1 for program name	*/
for (i = 0; i < argc_l; i++)
	SET_OBJECT_ARRAY_ELEMENT(argv, i,
		(JSTRING)makeJavaString (argv_l [i+1], strlen(argv_l [i+1])));
free(argv_l);

mpi_const = (Jint)MPI_GROUP_NULL;
#undef MPI_GROUP_NULL
STORE_CONSTANT(MPI_GROUP_NULL, (JOBJECT(HMPI_Group)), "LMPI_Group;", mpi_group);

mpi_const = (Jint)MPI_COMM_NULL;
#undef MPI_COMM_NULL
STORE_CONSTANT(MPI_COMM_NULL, (JOBJECT(HMPI_Comm)), "LMPI_Comm;", mpi_comm);

mpi_const = (Jint)MPI_DATATYPE_NULL;
#undef MPI_DATATYPE_NULL
STORE_CONSTANT(MPI_DATATYPE_NULL, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_REQUEST_NULL;
#undef MPI_REQUEST_NULL
STORE_CONSTANT(MPI_REQUEST_NULL, (JOBJECT(HMPI_Request)), "LMPI_Request;", mpi_request);

mpi_const = (Jint)MPI_OP_NULL;
#undef MPI_OP_NULL
STORE_CONSTANT(MPI_OP_NULL, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_COMM_WORLD;
#undef MPI_COMM_WORLD		/* initialize MPI_COMM_WORLD	*/
STORE_CONSTANT(MPI_COMM_WORLD, (JOBJECT(HMPI_Comm)), "LMPI_Comm;", mpi_comm);

mpi_const = (Jint)MPI_COMM_SELF;
#undef MPI_COMM_SELF
STORE_CONSTANT(MPI_COMM_SELF, (JOBJECT(HMPI_Comm)), "LMPI_Comm;", mpi_comm);

mpi_const = (Jint)MPI_GROUP_EMPTY;
#undef MPI_GROUP_EMPTY
STORE_CONSTANT(MPI_GROUP_EMPTY, (JOBJECT(HMPI_Group)), "LMPI_Group;", mpi_group);

mpi_const = (Jint)MPI_MAX;
#undef MPI_MAX
STORE_CONSTANT(MPI_MAX, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_MIN;
#undef MPI_MIN
STORE_CONSTANT(MPI_MIN, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_SUM;
#undef MPI_SUM
STORE_CONSTANT(MPI_SUM, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_PROD;
#undef MPI_PROD
STORE_CONSTANT(MPI_PROD, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_LAND;
#undef MPI_LAND
STORE_CONSTANT(MPI_LAND, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_BAND;
#undef MPI_BAND
STORE_CONSTANT(MPI_BAND, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_LOR;
#undef MPI_LOR
STORE_CONSTANT(MPI_LOR, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_BOR;
#undef MPI_BOR
STORE_CONSTANT(MPI_BOR, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_LXOR;
#undef MPI_LXOR
STORE_CONSTANT(MPI_LXOR, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_BXOR;
#undef MPI_BXOR
STORE_CONSTANT(MPI_BXOR, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_MAXLOC;
#undef MPI_MAXLOC
STORE_CONSTANT(MPI_MAXLOC, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_MINLOC;
#undef MPI_MINLOC
STORE_CONSTANT(MPI_MINLOC, (JOBJECT(HMPI_Op)), "LMPI_Op;", mpi_op);

mpi_const = (Jint)MPI_BYTE;
#undef MPI_BYTE
STORE_CONSTANT(MPI_BYTE, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_PACKED;
#undef MPI_PACKED
STORE_CONSTANT(MPI_PACKED, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_CHAR;
#undef MPI_CHAR
STORE_CONSTANT(MPI_CHAR, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_SHORT;
#undef MPI_SHORT
STORE_CONSTANT(MPI_SHORT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_INT;
#undef MPI_INT
STORE_CONSTANT(MPI_INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_LONG;
#undef MPI_LONG
STORE_CONSTANT(MPI_LONG, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_FLOAT;
#undef MPI_FLOAT
STORE_CONSTANT(MPI_FLOAT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_DOUBLE;
#undef MPI_DOUBLE
STORE_CONSTANT(MPI_DOUBLE, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_LONG_DOUBLE;
#undef MPI_LONG_DOUBLE
STORE_CONSTANT(MPI_LONG_DOUBLE, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_UNSIGNED_CHAR;
#undef MPI_UNSIGNED_CHAR
STORE_CONSTANT(MPI_UNSIGNED_CHAR, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_UNSIGNED_SHORT;
#undef MPI_UNSIGNED_SHORT
STORE_CONSTANT(MPI_UNSIGNED_SHORT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_UNSIGNED_LONG;
#undef MPI_UNSIGNED_LONG
STORE_CONSTANT(MPI_UNSIGNED_LONG, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_UNSIGNED;
#undef MPI_UNSIGNED
STORE_CONSTANT(MPI_UNSIGNED, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_FLOAT_INT;
#undef MPI_FLOAT_INT
STORE_CONSTANT(MPI_FLOAT_INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_DOUBLE_INT;
#undef MPI_DOUBLE_INT
STORE_CONSTANT(MPI_DOUBLE_INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_LONG_DOUBLE_INT;
#undef MPI_LONG_DOUBLE_INT
STORE_CONSTANT(MPI_LONG_DOUBLE_INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_LONG_INT;
#undef MPI_LONG_INT
STORE_CONSTANT(MPI_LONG_INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_SHORT_INT;
#undef MPI_SHORT_INT
STORE_CONSTANT(MPI_SHORT_INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_2INT;
#undef MPI_2INT
STORE_CONSTANT(MPI_2INT, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_UB;
#undef MPI_UB
STORE_CONSTANT(MPI_UB, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_LB;
#undef MPI_LB
STORE_CONSTANT(MPI_LB, (JOBJECT(HMPI_Datatype)), "LMPI_Datatype;", mpi_datatype);

mpi_const = (Jint)MPI_ERRORS_ARE_FATAL;
#undef MPI_ERRORS_ARE_FATAL
STORE_CONSTANT(MPI_ERRORS_ARE_FATAL, (JOBJECT(HMPI_Errhandler)), "LMPI_Errhandler;", mpi_errhandler);

mpi_const = (Jint)MPI_ERRORS_RETURN;
#undef MPI_ERRORS_RETURN
STORE_CONSTANT(MPI_ERRORS_RETURN, (JOBJECT(HMPI_Errhandler)), "LMPI_Errhandler;", mpi_errhandler);


mpi_const = (Jint)MPI_IDENT;
#undef MPI_IDENT
STORE_INT(MPI_IDENT);

mpi_const = (Jint)MPI_CONGRUENT;
#undef MPI_CONGRUENT
STORE_INT(MPI_CONGRUENT);

mpi_const = (Jint)MPI_SIMILAR;
#undef MPI_SIMILAR
STORE_INT(MPI_SIMILAR);

mpi_const = (Jint)MPI_UNEQUAL;
#undef MPI_UNEQUAL
STORE_INT(MPI_UNEQUAL);

mpi_const = (Jint)MPI_ANY_SOURCE;
#undef MPI_ANY_SOURCE
STORE_INT(MPI_ANY_SOURCE);

mpi_const = (Jint)MPI_PROC_NULL;
#undef MPI_PROC_NULL
STORE_INT(MPI_PROC_NULL);

mpi_const = (Jint)MPI_ANY_TAG;
#undef MPI_ANY_TAG
STORE_INT(MPI_ANY_TAG);

mpi_const = (Jint)MPI_MAX_PROCESSOR_NAME;
#undef MPI_MAX_PROCESSOR_NAME
STORE_INT(MPI_MAX_PROCESSOR_NAME);

mpi_const = (Jint)MPI_MAX_ERROR_STRING;
#undef MPI_MAX_ERROR_STRING
STORE_INT(MPI_MAX_ERROR_STRING);

mpi_const = (Jint)MPI_UNDEFINED;
#undef MPI_UNDEFINED
STORE_INT(MPI_UNDEFINED);

mpi_const = (Jint)MPI_CART;
#undef MPI_CART
STORE_INT(MPI_CART);

mpi_const = (Jint)MPI_GRAPH;
#undef MPI_GRAPH
STORE_INT(MPI_GRAPH);

mpi_const = (Jint)MPI_KEYVAL_INVALID;
#undef MPI_KEYVAL_INVALID
STORE_INT(MPI_KEYVAL_INVALID);

mpi_const = (Jint)MPI_TAG_UB;
#undef MPI_TAG_UB
STORE_INT(MPI_TAG_UB);

mpi_const = (Jint)MPI_HOST;
#undef MPI_HOST
STORE_INT(MPI_HOST);

mpi_const = (Jint)MPI_IO;
#undef MPI_IO
STORE_INT(MPI_IO);

mpi_const = (Jint)MPI_WTIME_IS_GLOBAL;
#undef MPI_WTIME_IS_GLOBAL
STORE_INT(MPI_WTIME_IS_GLOBAL);

mpi_const = (Jint)MPI_BOTTOM;
#undef MPI_BOTTOM
STORE_INT(MPI_BOTTOM);

mpi_const = (Jint)MPI_BSEND_OVERHEAD;
#undef MPI_BSEND_OVERHEAD
STORE_INT(MPI_BSEND_OVERHEAD);

return ierr;
}

/**********************************************************************/


